## budgie-display-configurator 0.0.1

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: Budgie Desktop Developers
#
# SPDX-License-Identifier: MPL-2.0

cmake_minimum_required(VERSION 3.20)

project(budgie-display-configurator VERSION 0.0.1)

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_STANDARD 23)

set(KDE_COMPILERSETTINGS_LEVEL 6.0)

set(PROJECT_DEP_VERSION "6.1.80")
set(QT_MIN_VERSION "6.8")
set(KF6_MIN_VERSION "6.6.0")

find_package(ECM ${KF6_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDEClangFormat)
include(KDEGitCommitHooks)
include(FeatureSummary)
include(ECMSetupVersion)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(GenerateExportHeader)
include(ECMGenerateHeaders)
include(ECMFindQmlModule)
include(ECMQmlModule)

find_package(Qt6 ${QT6_MIN_VERSION} NO_MODULE COMPONENTS Core DBus Gui Quick QuickControls2 Widgets)

set_package_properties(
  Qt6 PROPERTIES
  TYPE REQUIRED
  PURPOSE "Basic application components")

find_package(
  KF6 ${KF6_MIN_VERSION}
  COMPONENTS ColorScheme
             CoreAddons
             I18n
             Kirigami
             QQC2DesktopStyle)

set_package_properties(
  KF6 PROPERTIES
  TYPE REQUIRED
  PURPOSE "Basic application components")

set_package_properties(
  KF6Kirigami PROPERTIES
  TYPE REQUIRED
  PURPOSE "Kirigami application UI framework")

# TODO(JoshStrobl): Add ecm_setup_version call for version setting -- uses the incldue of ECMSetupVersion

add_subdirectory(src)

install(TARGETS org.buddiesofbudgie.DisplayConfig ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.buddiesofbudgie.DisplayConfig.desktop DESTINATION ${KDE_INSTALL_APPDIR})

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: Budgie Desktop Developers
#
# SPDX-License-Identifier: MPL-2.0

add_subdirectory(libdisplayconfig)

ecm_find_qmlmodule(org.kde.kirigami REQUIRED)

add_executable(org.buddiesofbudgie.DisplayConfig)
ecm_add_qml_module(
    org.buddiesofbudgie.DisplayConfig
    URI
    "org.buddiesofbudgie.DisplayConfig"
    GENERATE_PLUGIN_SOURCE
)

target_sources(org.buddiesofbudgie.DisplayConfig
    PRIVATE
    main.cpp
)

ecm_target_qml_sources(org.buddiesofbudgie.DisplayConfig
    SOURCES
    qml/Main.qml
    qml/LayoutManager.qml
)

target_link_libraries(org.buddiesofbudgie.DisplayConfig
    PRIVATE
    Qt6::Core
    Qt6::DBus
    Qt6::Quick
    Qt6::Qml
    Qt6::Gui
    Qt6::QuickControls2
    Qt6::Widgets
    KF6::ColorScheme
    KF6::CoreAddons
    KF6::I18n
    KF6::I18nQml
    libdisplayconfig
)

=== src/libdisplayconfig/CMakeLists.txt ===
# SPDX-FileCopyrightText: Budgie Desktop Developers
#
# SPDX-License-Identifier: MPL-2.0

set(backend_SRCS)

qt_add_dbus_interface(backend_SRCS dbus/schemas/DisplaySchema.BatchSystem.xml BatchSystemInterface)
qt_add_dbus_interface(backend_SRCS dbus/schemas/DisplaySchema.Displays.xml DisplaysInterface)
qt_add_dbus_interface(backend_SRCS dbus/schemas/DisplaySchema.Output.xml OutputInterface)
qt_add_dbus_interface(backend_SRCS dbus/schemas/DisplaySchema.OutputMode.xml OutputModeInterface)

add_library(
    libdisplayconfig STATIC
    backend.cpp
    backend.hpp
    enums/connectionstate.hpp
    layout.cpp
    layout.hpp
    models/layoutmodel.cpp
    models/layoutmodel.hpp
    models/outputmodel.cpp
    models/outputmodel.hpp
    output/output.cpp
    output/output.hpp
    ${backend_SRCS}
)

generate_export_header(libdisplayconfig BASE_NAME LibDisplayConfig)

target_include_directories(libdisplayconfig PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/enums ${CMAKE_CURRENT_SOURCE_DIR}/models)

target_link_libraries(libdisplayconfig PRIVATE Qt::Core Qt::DBus Qt::Qml)

=== debian/changelog ===
budgie-display-configurator (0.0.1-1) experimental; urgency=medium

  * Initial Release (Closes: #1120917)

 -- David Mohammed <fossfreedom@ubuntu.com>  Thu, 23 Oct 2025 20:38:59 +0100

=== debian/control ===
Source: budgie-display-configurator
Section: misc
Priority: optional
Maintainer: David Mohammed <fossfreedom@ubuntu.com>
Homepage: https://forge.moderndesktop.dev/BuddiesOfBudgie/budgie-display-configurator
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 cmake-extras,
 extra-cmake-modules,
 kirigami-addons-dev,
 libkf6bluezqt-dev,
 libkf6colorscheme-dev,
 libkf6config-dev,
 libkf6coreaddons-dev,
 libkf6dbusaddons-dev,
 libkf6i18n-dev,
 libkf6qqc2desktopstyle-dev,
 libkirigami-dev,
 libqt6qmlcompiler6,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-tools-dev,
Standards-Version: 4.7.2
Vcs-Browser: https://github.com/ubuntubudgie/budgie-display-configurator/tree/debian
Vcs-Git: https://github.com/ubuntubudgie/budgie-display-configurator.git -b debian


Package: budgie-display-configurator
Architecture: any
Depends:
 qml6-module-org-kde-bluezqt,
 qml6-module-org-kde-config,
 qml6-module-org-kde-kirigamiaddons-statefulapp,
 qml6-module-qtquick-controls,
 qml6-module-qtquick-dialogs,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends: budgie-desktop-services,
Description: Graphical display configuration tool for the Budgie Desktop
 Budgie Display Configurator is a graphical configuration tool for the
 Budgie Desktop.
 It primarily provides the ability to configure Display orientation,
 refresh and other aspects of display management.
 .
 The tool is tightly integrated with budgie-display-services which manages
 the setting of the Wayland aspects of display configuration.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

=== debian/watch ===
Version: 5

Source: https://forge.moderndesktop.dev/BuddiesOfBudgie/budgie-display-configurator/tags
Matching-Pattern: .*/@ANY_VERSION@@ARCHIVE_EXT@
